SystemOrganization addCategory: #'CS528-SetbackProject-Tests'!

TestCase subclass: #SetbackTestCase
	instanceVariableNames: 'sortedDeck'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject-Tests'!

SetbackTestCase subclass: #CardHandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject-Tests'!

!CardHandTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 21:16'!
testHandAdditionCapacity
|hand deck|
deck:= (Deck createStandardDeck).
hand:= (CardHand addCard: deck dealNext).
self assert: (hand cards size) = 1.
(hand addCard: deck dealNext).
self assert: (hand cards size) = 2.
(hand addCard: deck dealNext).
self assert: (hand cards size) = 3.
(hand addCard: deck dealNext).
self assert: (hand cards size) = 4.
(hand addCard: deck dealNext).
self assert: (hand cards size) = 5.
(hand addCard: deck dealNext).
self assert: (hand cards size) = 6.
self should: [ (hand addCard: deck dealNext). ] raise: TestResult error.
! !

!CardHandTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 21:16'!
testHandRemovalCapacity
|hand card|
card:= (Card value: #two suit: #hearts).
hand:= (CardHand addCard: card).
self assert: (hand capacity) = 6.
self assert: (hand cards size) = 1.
(hand removeCard: card).
self should: [ (hand removeCard: card). ] raise: TestResult error.
! !

!CardHandTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 21:16'!
testHandUniqueness
|hand card|
card:= (Card value: #two suit: #hearts).
hand:= (CardHand addCard: card).
self assert: (hand capacity) = 6.
self assert: (hand cards size) = 1.
(CardHand addCard: card).
self assert: (hand cards size) = 1.! !

SetbackTestCase subclass: #CardTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject-Tests'!

!CardTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 11:07'!
testCardUniqueness
|card|
card:= (Card value: #two suit: #hearts).
self should: [ card value: #two suit: #hearts ] raise: TestResult error.! !

!CardTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/28/2013 15:29'!
testInvalidCardCreation
self should: [(Card value: #two unit: #two)] raise: TestResult error.
self should: [(Card value: #hearts unit: #hearts)] raise: TestResult error.! !

!CardTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 11:07'!
testSimpleCardCreation
self assert: ((Card value: #two suit: #hearts) value) = #two.
self assert: ((Card value: #two suit: #hearts) suit) = #hearts.! !

SetbackTestCase subclass: #DeckTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject-Tests'!

!DeckTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 21:16'!
testDeckCreation
self assert: (Deck new cards = nil).
self assert: (Deck createStandardDeck cards size = 52).
self assert: (Deck createStandardDeck cards includes: (Card value: #ace suit: #hearts)).
self assert: (Deck createStandardDeck cards includes: (Card value: #king suit: #diamonds)).
self assert: (Deck createStandardDeck cards includes: (Card value: #queen suit: #spades)).
self assert: (Deck createStandardDeck cards includes: (Card value: #jack suit: #clubs)).
self assert: (Deck createStandardDeck cards includes: (Card value: #ten suit: #hearts)).
self assert: (Deck createStandardDeck cards includes: (Card value: #nine suit: #diamonds)).
self assert: (Deck createStandardDeck cards includes: (Card value: #eight suit: #spades)).
self assert: (Deck createStandardDeck cards includes: (Card value: #seven suit: #clubs)).
self assert: (Deck createStandardDeck cards includes: (Card value: #six suit: #clubs)).
self assert: (Deck createStandardDeck cards includes: (Card value: #five suit: #hearts)).
self assert: (Deck createStandardDeck cards includes: (Card value: #four suit: #diamonds)).
self assert: (Deck createStandardDeck cards includes: (Card value: #three suit: #spades)).
self assert: (Deck createStandardDeck cards includes: (Card value: #two suit: #clubs)).! !

!DeckTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/28/2013 19:44'!
testDeckDealing
|deck|
deck:= Deck createStandardDeck.
1 to: 52 do: [ :i | deck dealNext ].
self should: [deck dealNext] raise: TestResult error.! !

!DeckTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 17:43'!
testDeckSingleton
|deck|
deck:= Deck createStandardDeck.
self should: [(deck createStandardDeck )] raise: TestResult error.! !

!SetbackTestCase methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 17:57'!
setUp
sortedDeck:= TestDeck new populateFrenchDeck! !

SetbackTestCase subclass: #SetbackTrickTest
	instanceVariableNames: 'oneHeart oneClub oneDiamond oneSpade'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject-Tests'!

!SetbackTrickTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 21:17'!
setUp
super setUp.

oneHeart:= CardHand new.
oneHeart addCard: (sortedDeck at: 1);
	addCard: (sortedDeck at: 2);
	addCard: (sortedDeck at: 3);
	addCard: (sortedDeck at: 4);
	addCard: (sortedDeck at: 6);
	addCard: (sortedDeck at: 7).
	
oneDiamond:= CardHand new.
oneDiamond addCard: (sortedDeck at: 50);
	addCard: (sortedDeck at: 8);
	addCard: (sortedDeck at: 41);
	addCard: (sortedDeck at: 10);
	addCard: (sortedDeck at: 11);
	addCard: (sortedDeck at: 12).
	
oneClub:= CardHand new.
oneClub addCard: (sortedDeck at: 13);
	addCard: (sortedDeck at: 14);
	addCard: (sortedDeck at: 15);
	addCard: (sortedDeck at: 16);
	addCard: (sortedDeck at: 17);
	addCard: (sortedDeck at: 18).
	
oneSpade:= CardHand new.
oneSpade addCard: (sortedDeck at: 19);
	addCard: (sortedDeck at: 20);
	addCard: (sortedDeck at: 21);
	addCard: (sortedDeck at: 22);
	addCard: (sortedDeck at: 23);
	addCard: (sortedDeck at: 25).! !

!SetbackTrickTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 21:17'!
testOpeningTrick
|trick|
"4 of hearts"
trick:= SetbackTrick playFirstCardOfNewGame: (sortedDeck at: 2) inHand: oneHeart.
"ace of hearts"
trick playCard: (sortedDeck at: 50) inHand: oneDiamond.
"5 of hearts"
trick playCard: (sortedDeck at: 14) inHand: oneClub.
"queen of hearts"
trick playCard: (sortedDeck at: 22) inHand: oneSpade.
self assert: trick leadCard suit = #hearts.
self assert: trick leadCard value = #four.
self assert: trick winningCard suit = #hearts.
self assert: trick winningCard value = #ace.
self assert: trick cards size = 4.
self assert: trick trumpSuit = #hearts.! !

!SetbackTrickTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 21:17'!
testTrickCantFollowSuit
|trick|
trick:= SetbackTrick playFirstCardOfNewGame: (sortedDeck at: 1) inHand: oneHeart.
trick playCard:  (sortedDeck at: 41) inHand: oneDiamond.
trick playCard: (sortedDeck at: 10) inHand: oneDiamond.
self assert: (trick cards size) = 3.
self assert: (trick leadCard) = (sortedDeck at: 1).
self assert: (trick trumpSuit) = (sortedDeck at: 1) suit.
self assert: (trick winningCard) =  (sortedDeck at: 41).! !

!SetbackTrickTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 21:17'!
testTrickCardNotInHand
|trick|
trick:= SetbackTrick playFirstCardOfNewGame: (sortedDeck at: 1) inHand: oneHeart.
trick playCard:  (sortedDeck at: 41) inHand: oneDiamond.
self should: [ trick playCard: (sortedDeck at: 52) inHand: oneDiamond. ] raise: TestResult error.! !

!SetbackTrickTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 21:17'!
testTrickCreation
|trick|
trick:= SetbackTrick leadCard: (sortedDeck at: 50) inHand: oneDiamond. 
self assert: trick leadCard suit = #hearts.
self assert: trick leadCard value = #ace.
self assert: trick cards size = 1.! !

!SetbackTrickTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 21:17'!
testTrickCreationNewGame
|trick|
trick:= SetbackTrick playFirstCardOfNewGame: (sortedDeck at: 50) inHand: oneDiamond.
self assert: trick leadCard suit = #hearts.
self assert: trick leadCard value = #ace.
self assert: trick cards size = 1.
self assert: trick trumpSuit = #hearts.! !

!SetbackTrickTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 21:17'!
testTrickFailToFollowSuit
|trick|
trick:= SetbackTrick playFirstCardOfNewGame: (sortedDeck at: 1) inHand: oneHeart. 
self should: [ trick playCard: (sortedDeck at: 10) inHand: oneDiamond ] raise: TestResult error.! !

!SetbackTrickTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 21:17'!
testTrickTrumpIn
|trick|
"Change trump to hearts"
SetbackTrick playFirstCardOfNewGame: (sortedDeck at: 2) inHand: oneHeart.
"create a new trick and lead with 10 of clubs"
trick:= SetbackTrick leadCard: (sortedDeck at: 7) inHand: oneHeart.
"trump in with 5 of hearts"
trick playCard: (sortedDeck at: 14) inHand: oneClub.
"throw a club to follow suit"
trick playCard: (sortedDeck at: 19) inHand: oneSpade.
"throw another trump"
trick playCard: (sortedDeck at: 10) inHand: oneDiamond.
self assert: trick leadCard suit = #clubs.
self assert: trick leadCard value = #ten.
self assert: trick winningCard suit = #hearts.
self assert: trick winningCard value = #five.
self assert: trick cards size = 4.
self assert: trick trumpSuit = #hearts.! !

!SetbackTrickTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 21:18'!
testTrickUniqueCards
|trick hand|
trick:= SetbackTrick playFirstCardOfNewGame: (sortedDeck at: 50) inHand: oneDiamond. 
hand:= CardHand addCard: (sortedDeck at: 50).
self assert: (trick playCard: (sortedDeck at: 50) inHand: hand) cards size = 1.! !
